
$fn = 200;

// Nuts and bolts dimensions
M3_hole = 3.2;
M3_nut_e = 6.4;

// Ball bearing dimensions
bb_do = 30+0.2;
bb_h = 9 + 2;
bb_di = 10;

// Aluminum bar dimensions for chassis frame
bar_e = 20;
bar_wall = 1;

// Standard servo dimensions
servo_w = 20;
servo_l = 40;
servo_lt = 53;
servo_h1 = 26.67;
servo_h2 = 9.35;
servo_h = servo_h1 + servo_h2;
servo_m_d = 10.15;
servo_m_l = (servo_lt-servo_l)/2;

servo_cut_w = 41;
servo_cut_h = 21;
servo_mount_x = 50/2;
servo_mount_d = 10;
servo_mount_d2 = 48.76;
servo_axis_offset = 9.66;

// Board dimensions
board_l = 130;
board_w = 55;
board_h = 30;

wheel_d = 165;
wheel_w = 48;
tire_d = wheel_w * 1.3;


// Track dimensions
track_l = 57.5;
track_h = 26;
track_wall = 3.5;
track_w = wheel_w + 3 * track_wall;
link_w = 20;
track_tolerance_w = 0.6;
tow = 8; //Tracks On Wheel

ch_dis_x = 10;
ch_dis_y = 10;

Assembled = 0;

if(Assembled == 0){
//  cable_chain();
//  spikes();
  drive_wheel();
//  wheel([0.98, 0.98, 1]);
//  tire();
//  camera_mount();
//  servo_mount();
//  board_mount();
//  pi_mount();
//  arduino_mount();
//  buck_converter_mount();
//  LED_board_mount();
}
else{
  
  //12V 44aH Lead acid battery
  translate([0, 0, 100]){
    cube(size=[210, 180, 180], center=true);
  }
  
  
  for(i=[0:1:1]){
    mirror([0,i,0]){
      translate([0, -60, 45]){
  //      board_mount(1);
      }
    }
  }

  if(Assembled){
    translate([0, 0, 50]){
      chassis();
    }

    translate([175, 0, 38]){
      rotate([0, 0, -90]){
        camera_mount();
      }
    }

    for(i=[0:1:1]){
      mirror([0, i, 0]){  
        translate([100, 170, -10]){
          rotate([90, 0, 0]){
            wheel();
          }
        }
        translate([-100, 170, -10]){
          rotate([90, 0, 0]){
            tire();
          }
        }
      }
    }

    translate([100, 170, -110]){
      rotate([0, 0, 0]){
        cable_chain();
      }
    }


  }
}

translate([0, 0, 50]){
//  servo_horn();
}

module LED_board_mount(){
  bcm_l = 55;
  bcm_w = 80;
  bcm_wall = 2;
  bcm_h = 5;
  bcm_shift = 5.5;
  
  // Mount on chassis
  hole_d = 5.2;
  hole_distance = 17.5;
  hole_w = 10;
  hole_edge = 6;
  
  
  // LED board dimensions
  raster = 2.54;
  bc_w = raster * 21;
  bc_l = raster * 16;
  screw_x = 7.0 * raster;
  screw_y = 9.5 * raster;
  
  difference(){
    union(){
      roundedRect([bcm_l, bcm_w, bcm_wall], 3);
      translate([screw_x, -screw_y-bcm_shift, bcm_h/2]){
        cylinder(d1=8, d2=5, h=bcm_h, center=true);
      }
      translate([-screw_x, screw_y-bcm_shift, bcm_h/2]){
        cylinder(d1=8, d2=5, h=bcm_h, center=true);
      }
    }
    //Chassis mount holes
    hull(){
      translate([hole_distance+hole_w/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
      translate([hole_distance-hole_w/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
    }
    hull(){
      translate([-hole_w/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
      translate([hole_w/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
    }
    hull(){
      translate([-hole_distance-hole_w/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
      translate([-hole_distance+hole_w/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
    }
    //Board mount holes
    translate([screw_x, -screw_y-bcm_shift, bcm_h/2]){
      cylinder(d=1.5, h=bcm_h*1.1, center=true);
    }
    translate([-screw_x, screw_y-bcm_shift, bcm_h/2]){
      cylinder(d=1.5, h=bcm_h*1.1, center=true);
    }
  }
  
}



module buck_converter_mount(){
  bcm_l = 50;
  bcm_w = 40;
  bcm_wall = 2;
  bcm_h = 5;
  bcm_shift = 7.5;
  
  // Mount on chassis
  hole_d = 4.5;
  hole_distance = 20;
  hole_w = 6;
  hole_edge = 6;
  
  
  // Converter board dimensions
  bc_l = 43.5;
  bc_w = 21.5;
  screw_x = bc_l/2 - 6.5;
  screw_y = bc_w/2 - 2.5;
  
  difference(){
    union(){
      roundedRect([bcm_l, bcm_w, bcm_wall], 3);
      translate([screw_x, -screw_y-bcm_shift, bcm_h/2]){
        cylinder(d1=8, d2=5, h=bcm_h, center=true);
      }
      translate([-screw_x, screw_y-bcm_shift, bcm_h/2]){
        cylinder(d1=8, d2=5, h=bcm_h, center=true);
      }
    }
    //Chassis mount holes
    hull(){
      translate([(hole_distance+hole_w)/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
      translate([(hole_distance-hole_w)/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
    }
    hull(){
      translate([-(hole_distance+hole_w)/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
      translate([-(hole_distance-hole_w)/2, bcm_w/2-hole_edge, bcm_h/2]){
        cylinder(d=hole_d, h=bcm_h*1.1, center=true);
      }
    }
    //Board mount holes
    translate([screw_x, -screw_y-bcm_shift, bcm_h/2]){
      cylinder(d=1.5, h=bcm_h*1.1, center=true);
    }
    translate([-screw_x, screw_y-bcm_shift, bcm_h/2]){
      cylinder(d=1.5, h=bcm_h*1.1, center=true);
    }
  }
  
}


module cable_chain(brim = 0){
  width=track_w;
  height=track_h;
  length=track_l;
  wall=track_wall;
  tolerance=0.6;
  tolerance_w=track_tolerance_w;
  tolerance_stop = 0.4;
  overlap=0.5;
  l_stop=length/2-(5-(length/2-height))-tolerance_stop;
  
  
  l=length-height;
  
  scale_a = height/(cos(180/8)*height);
  
  x1=l/2;
  y1=0;
  x2=l/2;
  y2=height/2;
  x3=l_stop;
  y3=height/2;
  x4=l_stop;
  y4=height/3;
  
  brim_h = 0.2;
  brim_d = 6;
  
  // Brim
  if(brim == 1){
    for(i=[0:1:1]){
      mirror([0, i, 0]){
        translate([track_l/3.5+2, (track_w-track_wall)/2, brim_h/2]){
          cylinder(d=brim_d, h=brim_h, center=true);
        }
        translate([-track_l/2.7-2, track_w/2+track_wall*0.7, brim_h/2]){
          cylinder(d=brim_d, h=brim_h, center=true);
        }
      }
    }
  }
  
  for(i=[0:1:1]){
    mirror([0, i, 0]){
      translate([0, -(width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          difference(){
            union(){
              translate([(l/2-overlap)/2, 0, 0]){
                cube(size=[l/2+overlap, height, wall], center=true);
              }
              //stopper
              translate([l_stop/2, -(height)/4, 0]){
                //cube(size=[l_stop, height/2, wall], center=true);
              }
              translate([-(l/2-overlap)/2, 0, wall+tolerance_w]){
                cube(size=[l/2+overlap, height, wall], center=true);
              }            
              translate([0, -height/2, -wall/2]){
                linear_extrude(height=wall){
                  polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
                }
              }
              mirror([0,1,0]){
                translate([0, -height/2, -wall/2]){
                  linear_extrude(height=wall){
                    polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
                  }
                }
              }              
              translate([-l/2, 0, wall+tolerance_w]){
                scale([1, scale_a]){
                  rotate([0, 0, 360/8/2]){
                    cylinder($fn=8, d=height, h=wall, center=true);
                  }
                }
              }
              translate([l/2, 0, wall]){
                cylinder(d1=height/2, d2=height/2-wall, h=wall, center=true);
              }
            }
            translate([-l/2, 0, wall+tolerance_w]){
              cylinder(d1=height/2, d2=height/2-wall, h=wall+0.025, center=true);
            }
            translate([0, -height/2-1.7, 5]){
              rotate([70, 0, 0]){
//                cube(size=[50, 5, 5], center=true);
              }
            }
          }
        }
      }
    }
  }

    //Center bottom plate  
    difference(){
      linear_extrude(height=17, scale=[0.7, 1]){
        square(size=[link_w, width-2*wall], center=true);
      }
      translate([-l/2, 0, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=width, center=true);
        }
      }
      translate([0, 0, tire_d/2+3.5]){
        rotate([90, 0, 90]){
          cylinder(d=tire_d, h=track_l, center=true);
        }
      }
      // Mount holes extra plates
      for(i=[0:1:1]){
        mirror([0,i,0]){
          translate([2, 20, 0]){
            rotate([0, 0, 0]){
              cylinder(d=M3_hole, h=track_h, center=true);
            }
          }
          translate([2, 20, track_h/2+2]){
            rotate([0, 0, 30]){
              cylinder(d=M3_nut_e, h=track_h, center=true, $fn=6);
            }
          }
        }
      }
    }
    difference(){
      translate([-link_w/4+overlap/2, (width-wall+tolerance_w)/2, height/2]){
        cube(size=[link_w/2+overlap, wall+tolerance_w, height], center=true);      
      }
      translate([-l/2, (width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=wall*2.1, center=true);
        }
      }
    }
    difference(){
      translate([-link_w/4+overlap/2, -(width-wall+tolerance_w)/2, height/2]){
        cube(size=[link_w/2+overlap, wall+tolerance_w, height], center=true);      
      }
      translate([-l/2, -(width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=wall*2.1, center=true);
        }
      }
    }
//  }
  
}

module spikes(){
  width=track_w;
  height=track_h;
  length=track_l;
  wall=track_wall;
    
  l=length-height;
  
  //Center bottom plate  
  difference(){
    linear_extrude(height=17, scale=[1.9, 1.5]){
      square(size=[link_w*0.4, width-2*wall-25], center=true);
    }
    translate([0, 0, tire_d/2+3.5]){
      rotate([90, 0, 90]){
        cylinder(d=tire_d, h=track_l, center=true);
      }
    }
  }
  
}


module drive_wheel(){
  horn_d = 41;
  horn_w1 = 12;
  horn_w2 = 6;
  horn_thickness = 3;
  horn_mount = 13.7;
  
  chain_l = track_l-track_h;
  echo(chain_l);
  echo(sin(90));
  chain_no = 15;
  radius = (chain_l/2)/tan(180/chain_no)+track_h/2;
  echo(radius);
  wheel_w = track_w-2*track_wall-track_tolerance_w-1;
  hub_d = 20;
  hub_h = wheel_w+5;
  hub_hole = 3.5;
  hub_hole_2 = 10;
  hub_hole_3 = 5.5;
  
  translate([0, 0, wheel_w/2]){
    translate([-90, 0, 0]){
      rotate([90, 0, 90]){
//        cable_chain();
      }
    }
    difference(){
      rotate_extrude(){
        union(){
          translate([(wheel_d-tire_d+11)/2, 0]){
            intersection(){
              circle(d=tire_d, center=true);
              square(size=[tire_d,wheel_w], center=true);
            }
          }
          translate([(wheel_d-tire_d)/4, 0]){
            square(size=[(wheel_d-tire_d)/2,wheel_w], center=true);
          }
        }
      }

      difference(){
        union(){
          for(i=[0:1:chain_no-1]){
            rotate([0, 0, 180/chain_no + 360/chain_no*i]){
              translate([tire_d, 0, 0]){
                rotate([90, 0, 90]){
                  linear_extrude(height=30, scale=[15,1]){
                    square(size=[2.8, wheel_w], center=true);
                  }
                }
              }
            }
          }
        }
        rotate_extrude(){
          union(){
            translate([(wheel_d-tire_d+3)/2, 0]){
              intersection(){
                circle(d=tire_d, center=true);
                square(size=[tire_d,wheel_w], center=true);
              }
            }
            translate([(wheel_d-tire_d)/4, 0]){
              square(size=[(wheel_d-tire_d)/2,wheel_w], center=true);
            }
          }
        }
      }
      
      cylinder(d=hub_hole, h=hub_h*1.5, center=true);
      cylinder(d=hub_hole_2, h=hub_h, center=true);
      translate([0, 0, -wheel_w/2]){
        cylinder(r=radius*1.1, h=10, center=true);
      }
      translate([0, 0, wheel_w/2]){
        cylinder(r=radius*1.1, h=10, center=true);
      }
      translate([0, 0, 0]){
        wheel(hub=0);
      }
    }
//    wheel(hub=0);
  }
  
}




module tire(){
  difference(){
    wheel();
    wheel([0.98, 0.98, 1.001]);
  }
}

module wheel(scaleXY=[1,1,1], hub=1){
  difference(){
    scale(scaleXY){
      rotate_extrude(){
        union(){
          translate([(wheel_d-tire_d)/2, 0]){
            intersection(){
              circle(d=tire_d, center=true);
              square(size=[tire_d,wheel_w], center=true);
            }
          }
          translate([(wheel_d-tire_d)/4, 0]){
            square(size=[(wheel_d-tire_d)/2,wheel_w], center=true);
          }
        }
      }
    }
    if(hub==1){
      difference(){
        cylinder(d=bb_do, h=wheel_w * 1.1, center=true);
        rotate_extrude(){
          cut_h = 3;
          x1 = bb_do/2;
          y1 = (wheel_w-2*bb_h)/2;
          x2 = bb_do/2;
          y2 = -(wheel_w-2*bb_h)/2;
          x3 = bb_do/2-cut_h;
          y3 = cut_h-(wheel_w-2*bb_h)/2;
          x4 = bb_do/2-cut_h;
          y4 = (wheel_w-2*bb_h)/2-cut_h;
          polygon(points=[[x1,y1], [x2,y2], [x3,y3], [x4,y4]]);
        }
      }
    }
  }
}

module chassis(){
  ch_w = 250;
  ch_l = 350;
  ch_h = 100;


  translate([0, (ch_w-bar_e)/2+50, (ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([(ch_l-bar_e)/2+50, 0, (ch_h-bar_e)/2]){
    bar(ch_w, [90,0,0]);
  }
  
  // Length
  translate([0, (ch_w-bar_e)/2, (ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([0, -(ch_w-bar_e)/2, (ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([0, (ch_w-bar_e)/2, -(ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  translate([0, -(ch_w-bar_e)/2, -(ch_h-bar_e)/2]){
    bar(ch_l, [0,90,0]);
  }
  // Height
  translate([ch_l/2-bar_e*1.5, ch_w/2-bar_e*1.5, 0]){
    bar(ch_h, [0,0,0]);
  }
  translate([-(ch_l/2-bar_e*1.5), ch_w/2-bar_e*1.5, 0]){
    bar(ch_h, [0,0,0]);
  }
  translate([-(ch_l/2-bar_e*1.5), -(ch_w/2-bar_e*1.5), 0]){
    bar(ch_h, [0,0,0]);
  }
  translate([ch_l/2-bar_e*1.5, -(ch_w/2-bar_e*1.5), 0]){
    bar(ch_h, [0,0,0]);
  }

  // Width
  translate([(ch_l-bar_e)/2, 0, (ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  translate([-(ch_l-bar_e)/2, 0, (ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  translate([-(ch_l-bar_e)/2, 0, -(ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  translate([(ch_l-bar_e)/2, 0, -(ch_h-bar_e)/2]){
    bar(ch_w-bar_e*2, [90,0,0]);
  }
  
}

module pi_mount(){
  //Raspberry Pi mount points
  raspi_m_l = 58;
  raspi_m_w = 49;
  raspi_m_shift_x = -10;
  raspi_m_shift_y = 0;
  raspi_m_d = 5;
  raspi_m_screw_d = 2;
  raspi_m_h = 6;
  raspi_m_socket = 1;  
  
  pm_wall = 2;
  pm_w = 74;
  pm_l = 100;
  
  wall_h = 8;
  mount_holes_x = 29;
  
  tower_m_d = 20;
  tower_m_x = -5;
  
  //Central cut
  cc_d = 20;
  cc_l = 25;
  
  //micro USB power supply cut
  psc_d = 50;
  psc_x = -30;
  psc_z = 27;

  
  translate([0, 0, pm_wall/2]){
    block_l = 4;
    block_w = 35;
    block_h = servo_w+5;
    block_edge = 8;

    
    difference(){
      union(){
        cube(size=[pm_l, pm_w, pm_wall], center=true);
        //Pi mount points
        translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall/2]){
          translate([raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
        }
        //Walls
        translate([(pm_l-pm_wall)/2, 0, raspi_m_h/2]){
          cube(size=[pm_wall, pm_w, raspi_m_h], center=true);
        }
        translate([(pm_l-pm_wall)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 35]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([(pm_wall-pm_l)/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall, pm_w, wall_h], center=true);
            translate([0, 0, 33]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([0, (pm_w-pm_wall)/2, wall_h/2]){
          cube(size=[pm_l, pm_wall, wall_h], center=true);
        }
        translate([0, -(pm_w-pm_wall)/2, wall_h/2]){
          cube(size=[pm_l, pm_wall, wall_h], center=true);
        }
      }
      //Mount holes on chassis
      translate([3.5*ch_dis_y-6.5, 2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([3.5*ch_dis_y-6.5, -2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([3.5-4.5*ch_dis_y, 0, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      //Central hole
      hull(){
        translate([cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
        translate([-cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
      }
      //Mount holes power pole
      holes = 9;
      for(i=[1:1:holes]){
        translate([-pm_l/2+i*ch_dis_x, pm_w/2, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
          }
        }
        translate([-pm_l/2+i*ch_dis_x, pm_w/2-pm_wall*1.5, 4]){
          rotate([90, 0, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
        if(i>3){
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
            }
          }
          translate([-pm_l/2+i*ch_dis_x, -pm_w/2+pm_wall*1.5, 4]){
            rotate([90, 0, 0]){
              cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
            }
          }
        }

      }
      // Cut micro USB for power supply
      translate([psc_x, -pm_w/2, psc_z]){
        rotate([90, 0, 0]){
          cylinder(d=psc_d, h=pm_wall*2.1, center=true);
        }
      }
      
      //Pi mount holes
      translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall]){
        translate([raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
      }
      
    }
    
  }
}

module arduino_mount(){
  //Arduino Uno mount points
  hole_shift_x = -21;
  hole_shift_y = -24;

  uno_hole1_x = 0 + hole_shift_x;
  uno_hole1_y = 0 + hole_shift_y;
  uno_hole2_x = 1.3 + hole_shift_x;
  uno_hole2_y = 15.2 + 27.9 + 5.1 + hole_shift_y;
  uno_hole3_x = 50.8 + 1.3 + hole_shift_x;
  uno_hole3_y = 27.9 + 5.1 + hole_shift_y;
  uno_hole4_x = uno_hole3_x;
  uno_hole4_y = 5.1 + hole_shift_y;
  
  hole_d = 1;
  mount_d = 4;
  mount_h = 4;
  
  
  um_wall = 2;
  um_w = 55;
  um_l = 70;  

  // Mount holes on chassis
  mh_d = 10;
  mh1_x = -(um_l + mh_d)/2;
  mh1_y = 0;
  mh2_x = (um_l + mh_d)/2;
  mh2_y = um_w/4;
  mh3_x = (um_l + mh_d)/2;
  mh3_y = -um_w/4;
  
  mh_h = 20;
  brim_h = 0.35;
  brim_d = 17;
  
  for(i=[0:1:2]){
    translate([i*12-12, 35, mh_h/2]){
      difference(){
        union(){
          cylinder(d=mh_d, h=mh_h, center=true);
          translate([0, 0, (brim_h-mh_h)/2]){
            cylinder(d=brim_d, h=brim_h, center=true);
          }
        }
        cylinder(d=M3_hole, h=mh_h*1.1, center=true);
      }
    }
  }
    
  difference(){
    union(){
      roundedRect([um_l, um_w, um_wall], 5);
      // Mounts on chassis
      translate([mh1_x, mh1_y, um_wall/2]){
        cylinder(d=mh_d, h=um_wall, center=true);
        translate([mh_d/4, 0, 0]){
          cube(size=[mh_d/2, mh_d, um_wall], center=true);
        }
      }
      translate([mh2_x, mh2_y, um_wall/2]){
        cylinder(d=mh_d, h=um_wall, center=true);
        translate([-mh_d/4, 0, 0]){
          cube(size=[mh_d/2, mh_d, um_wall], center=true);
        }
      }
      translate([mh3_x, mh3_y, um_wall/2]){
        cylinder(d=mh_d, h=um_wall, center=true);
        translate([-mh_d/4, 0, 0]){
          cube(size=[mh_d/2, mh_d, um_wall], center=true);
        }
      }
      
      // Mounts Arduino Uno
      translate([0, 0, mount_h/2+um_wall]){
        translate([uno_hole1_x, uno_hole1_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
        translate([uno_hole2_x, uno_hole2_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
        translate([uno_hole3_x, uno_hole3_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
        translate([uno_hole4_x, uno_hole4_y, 0]){
          cylinder(d1=mount_d*1.4, d2=mount_d, h=mount_h, center=true);
        }
      }
    }
    // Mount holes on chassis
    translate([mh1_x, mh1_y, um_wall/2]){
      cylinder(d=M3_hole, h=um_wall*1.1, center=true);
    }
    translate([mh2_x, mh2_y, um_wall/2]){
      cylinder(d=M3_hole, h=um_wall*1.1, center=true);
    }
    translate([mh3_x, mh3_y, um_wall/2]){
      cylinder(d=M3_hole, h=um_wall*1.1, center=true);
    }

    
    // Mount holes Arduino Uno
    translate([0, 0, (mount_h+um_wall)/2]){
      translate([uno_hole1_x, uno_hole1_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
      translate([uno_hole2_x, uno_hole2_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
      translate([uno_hole3_x, uno_hole3_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
      translate([uno_hole4_x, uno_hole4_y, 0]){
        cylinder(d=hole_d, h=(mount_h+um_wall)*1.1, center=true);
      }
    }
  }
    
}


module servo_mount(){
  
  s_w = 30;
  s_w2 = 50;
  s_l = 30;
  s_h = 80;
  s_wall = 2;

  //Clamp
  c_l = 57;
  c_w = 10;
  c_h = 15;
  c_mount_holes = 25;
  c_shift = 10;
  
  enf_l = 25;
  enf_h = 75;

  translate([s_h/2*(1-Assembled), 0, s_l/2*(1-Assembled)]){
    rotate([270*(1-Assembled), 0, 90*(1-Assembled)]){
      difference(){
        union(){
          roundedRect([s_w2, s_l, s_wall], 5, [1,1,1,1]);
          translate([0, s_l/2, s_h/2]){
            rotate([90, 0, 0]){
              roundedRect([s_w, s_h, s_wall], 5, [0,0,1,1]);
            }
          }
          hull(){
            translate([(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
          hull(){
            translate([-(s_wall-s_w)/2, (s_l-enf_l)/2, 0.05]){
              cube(size=[s_wall, enf_l, 0.1], center=true); 
            }
            translate([-(s_wall-s_w)/2, s_l/2, enf_h/2]){
              cube(size=[s_wall, 0.1, enf_h], center=true); 
            }
          }
        }
        // Clamp mount holes
        translate([0, 0, s_h/2-c_mount_holes+c_shift]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=200.1, center=true);
          }
        }    
        translate([0, 0, s_h/2+c_mount_holes+c_shift]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=200.1, center=true);
          }
        }    
        // Bottom mount holes
        for(i=[0:1:1])mirror([i, 0, 0]){
          translate([20, 10, 0]){
            cylinder(d=M3_hole, h=20.1, center=true);
          }    
          translate([20, 0, 0]){
            cylinder(d=M3_hole, h=20.1, center=true);
          }    
          translate([20, -10, 0]){
            cylinder(d=M3_hole, h=20.1, center=true);
          }    
        }
      }
    }
    
  }

  // Clamp
  translate([0, 25-Assembled*8, 23*Assembled+c_h/2]){
    rotate([90*Assembled, 90*Assembled, 0]){
      difference(){
        cube(size=[c_l, c_w, c_h], center=true);
        translate([0, 0, 4]){
          cube(size=[42, c_w*1.1, c_h], center=true);
        }
        translate([c_mount_holes, 0, 0]){
          cylinder(d=M3_hole, h=c_h*1.1, center=true);
        }    
        translate([-c_mount_holes, 0, 0]){
          cylinder(d=M3_hole, h=c_h*1.1, center=true);
        }    
      }
    }
  }
  
}


module camera_mount(){
  cam_w = 27;
  cam_h = 25;
  cam_l = 14;
  cam_pos = -1;
  cam_slot = 1.5;
  cam_slot_w = 3;

  cm_wall = 2;
  cm_w = cam_w + 35;
  cm_h = cam_h+cm_wall;
  lever_radius = 5;
  lever_z = cm_h/2-lever_radius;

  lever_l = 45;
  lever_radius = 5;
  lever_gap = 20;
  lever_z = lever_radius-cm_h/2;
  
  //Servo horn mount holes
  shm_l1 = lever_l - 13.7-21;

  lever2_l = -15;
  lever2_radius = 5;
  lever2_z = lever2_radius-cm_h/2;

  LED_d = 5.1;
  LED_w = cm_w - 16;
  LED_no = 3;

  translate([0, 0, 0]){
  
    //Camera box
    difference(){
      translate([0, 0, cm_h/2]){
        rotate([90, 0, 180]){
          difference(){
            roundedRect(size=[cm_w, cm_h, cm_wall], radius=3);
            gap = cm_h / LED_no;
            for(i=[0:1:LED_no-1]){
              translate([LED_w/2, (cm_h-gap)/2-i*gap, cm_wall/2]){
                cylinder(d=LED_d, h=cm_wall*1.1, center=true);
              }
              mirror([1, 0, 0]){
                translate([LED_w/2, (cm_h-gap)/2-i*gap, cm_wall/2]){
                  cylinder(d=LED_d, h=cm_wall*1.1, center=true);
                }
              }
            }
          }
          translate([0, 0, 0]){
            roundedRect(size=[cam_w+2*cm_wall, cm_h, cam_l], radius=2);
          }
        }
      }
      // Cut camera
      translate([0, cam_l/2+cm_wall-2, cm_h/2+cm_wall]){
        cube(size=[cam_w-2*cam_slot_w, cam_l-4, cam_h], center=true);
      }
      translate([0, cam_l/2+cm_wall, cm_h/2+cm_wall+12.5]){
        cube(size=[15, cam_l, cam_h], center=true);
      }
      translate([0, cam_l/2+cm_wall, cm_h/2+cm_wall]){
        rotate([90, 0, 0]){
          cylinder(d=15, h=cam_l, center=true);
        }
      }
      // Cut camera slit
      translate([0, cam_l/2+cam_pos, cm_h/2+cm_wall]){
        cube(size=[cam_w, cam_slot, cam_h], center=true);
      }
    }
    
    
    //Lever mounts
    translate([0, 0, cm_h/2]){
      rotate([0, 90, 0]){
        difference(){
          hull(){
            translate([-lever_z, -lever_l, 0]){
              cylinder(r=lever_radius, h=cm_wall, center=true);  
            }
            translate([0, cm_wall/2, 0]){
              cube(size=[cm_h, cm_wall, cm_wall], center=true);
            }
          }
          hull(){
            translate([-lever_z, -lever_l, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
            translate([-lever_z, -lever_l+(lever_l-shm_l1)/2-3, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
          }
          hull(){
            translate([-lever_z, -shm_l1, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
            translate([-lever_z, -lever_l+(lever_l-shm_l1)/2+3, 0]){
              cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
            }          
          }
        }
      }
    }
    
  }


}

module board_mount(showServo=0){
  bm_wall = 2;
  bm_h = 10;
  bm_w = board_w + 2*bm_wall+5;
  bm_l = board_l + 2*bm_wall+10;
  
  // Mount holes
  mh_edge_x = 45;
  mh_edge_y = 35;
  mh_d = 10;
  
  // Board mount holes
  bmh_x = board_l/2 - 4;
  bmh_y = board_w/2 - 6;
  
  // Spacers
  s1_h = 5;
  // Spacers mount points chassis
  for(i=[0:1:3])translate([bm_l/2+7, i*12-18, s1_h/2]){
    difference(){
      cylinder(d=mh_d, h=s1_h, center=true);
      cylinder(d=M3_hole, h=s1_h*1.1, center=true);
    }
  }
  brim_h = 0.35;
  // Brim
  difference(){
    translate([bm_l/2+5, 0, brim_h/2]){
      cube(size=[20, bm_w, brim_h], center=true);
    }
    for(i=[0:1:3])translate([bm_l/2+7, i*12-18, s1_h/2]){
      cylinder(d=M3_hole, h=s1_h*1.1, center=true);
    }
  }
  
  // Spacers mount points board
  for(i=[0:1:3])translate([-bm_l/2-7, i*12-18, s1_h/2]){
    difference(){
      cylinder(d=7, h=s1_h, center=true);
      cylinder(d=M3_hole, h=s1_h*1.1, center=true);
    }
  }
  // Brim
  difference(){
    translate([-bm_l/2-5, 0, brim_h/2]){
      cube(size=[20, bm_w, brim_h], center=true);
    }
    for(i=[0:1:3])translate([-bm_l/2-7, i*12-18, s1_h/2]){
      cylinder(d=M3_hole, h=s1_h*1.1, center=true);
    }
  }
  

  translate([0, 0, 0]){
    //Mount points chassis
    for(i=[0:1:1])mirror([0,i,0]){
      translate([mh_edge_x, mh_edge_y, bm_h/2]){
        difference(){
          union(){
            cylinder(d=mh_d, h=bm_h, center=true);
            translate([0, -mh_d/4, 0]){
              cube(size=[mh_d, mh_d/2, bm_h], center=true);
            }
          }
          cylinder(d=M3_hole, h=bm_h*1.1, center=true);
        }
      }
      translate([-mh_edge_x, mh_edge_y, bm_h/2]){
        difference(){
          union(){
            cylinder(d=mh_d, h=bm_h, center=true);
            translate([0, -mh_d/4, 0]){
              cube(size=[mh_d, mh_d/2, bm_h], center=true);
            }
          }
          cylinder(d=M3_hole, h=bm_h*1.1, center=true);
        }
      }
    }
    
    //base plate
    translate([0, 0, bm_wall/2]){
      difference(){
        cube(size=[bm_l, bm_w, bm_wall], center=true);
        //Board mount holes
        hull(){
          translate([bmh_x-2, bmh_y, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
          translate([bmh_x+2, bmh_y, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
        }
        hull(){
          translate([bmh_x-2, -bmh_y, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
          translate([bmh_x+2, -bmh_y, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
        }
        hull(){
          translate([-bmh_x, -bmh_y-2, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
          translate([-bmh_x, 2-bmh_y, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
        }
        hull(){
          translate([-bmh_x, bmh_y-2, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
          translate([-bmh_x, 2+bmh_y, 0]){
            cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
          }
        }
        translate([-bmh_x, -bmh_y, 0]){
          cylinder(d=M3_hole, h=bm_wall*10.1, center=true);
        }
        // Cut light sensor holes
        translate([95/2, 0, 0]){
          cylinder(d=20, h=bm_wall*10.1, center=true);
        }
        translate([-95/2, 0, 0]){
          cylinder(d=20, h=bm_wall*10.1, center=true);
        }              
      }
    }
    //walls
    translate([0, (bm_w-bm_wall)/2, bm_h/2]){
      cube(size=[bm_l, bm_wall, bm_h], center=true);
    }
    translate([0, -(bm_w-bm_wall)/2, bm_h/2]){
      cube(size=[bm_l, bm_wall, bm_h], center=true);
    }
    translate([(bm_l-bm_wall)/2, 0, bm_h/2]){
      cube(size=[bm_wall, bm_w, bm_h], center=true);
    }
    translate([-(bm_l-bm_wall)/2, 0, bm_h/2]){
      cube(size=[bm_wall, bm_w, bm_h], center=true);
    }
          
  }
  
  
}

module board_mount_old(showServo=0){
  bm_wall = 2;
  bm_h = 10;
  bm_w = board_w + 2*bm_wall+5;
  bm_l = board_l + 2*bm_wall+5;
  
  // Pivot mount dimensions
  pm_h = 50;
  pm_w = bm_w+22;
  pm_l = 63;
  pm_wall = 2;
  
  servo_shift = 10;
  shift_w = -17;
  
  // Mount holes
  mh_x = 25;
  mh_y = 25;
  
  // Board mount holes
  bmh_x = board_l/2 - 4;
  bmh_y = board_w/2 - 6;

  translate([servo_shift, shift_w, 0]){
  // Base box
    rotate([0, -40*0, 0]){
      difference(){  
        union(){
          //base plate
          translate([0, 0, bm_wall/2]){
            difference(){
              cube(size=[bm_l, bm_w, bm_wall], center=true);
              //Board mount holes
              hull(){
                translate([bmh_x-2, bmh_y, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
                translate([bmh_x+2, bmh_y, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
              }
              hull(){
                translate([bmh_x-2, -bmh_y, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
                translate([bmh_x+2, -bmh_y, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
              }
              hull(){
                translate([-bmh_x, -bmh_y-2, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
                translate([-bmh_x, 2-bmh_y, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
              }
              hull(){
                translate([-bmh_x, bmh_y-2, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
                translate([-bmh_x, 2+bmh_y, 0]){
                  cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
                }
              }
              translate([-bmh_x, -bmh_y, 0]){
                cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
              }
              // Cut light sensor holes
              translate([95/2, 0, 0]){
                cylinder(d=20, h=pm_wall*10.1, center=true);
              }
              translate([-95/2, 0, 0]){
                cylinder(d=20, h=pm_wall*10.1, center=true);
              }              
            }
          }
          //walls
          translate([0, (bm_w-bm_wall)/2, bm_h/2]){
            cube(size=[bm_l, bm_wall, bm_h], center=true);
          }
          translate([0, -(bm_w-bm_wall)/2, bm_h/2]){
            cube(size=[bm_l, bm_wall, bm_h], center=true);
          }
          translate([(bm_l-bm_wall)/2, 0, bm_h/2]){
            cube(size=[bm_wall, bm_w, bm_h], center=true);
          }
          translate([-(bm_l-bm_wall)/2, 0, bm_h/2]){
            cube(size=[bm_wall, bm_w, bm_h], center=true);
          }
          
        }
        translate([0, bm_w/2+bm_wall, bm_h/2]){
          rotate([-90, 0, 0]){
            servo_horn();
          }
        }
        translate([0, -(bm_w/2+bm_wall), bm_h/2]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=10, center=true);
          }
        }
      }
    }
  }
  
  // Pivot mount
  translate([0, shift_w/2+70*(1-Assembled), (pm_h-bm_h/2)*(1-Assembled)]){
    difference(){
      union(){
        hull(){
          translate([0, -pm_w/2, bm_h/2-pm_h+0.05]){
            cube(size=[pm_l, pm_wall, 0.1], center=true);
          }
          translate([servo_shift, -pm_w/2, bm_h/2]){
            rotate([90, 0, 0]){
              cylinder(d=10, h=pm_wall, center=true);
            }
          }
        }
        hull(){
          translate([servo_shift, -pm_w/4, bm_h/2-pm_h+0.05]){
            cube(size=[pm_wall, pm_w/2, 0.1], center=true);
          }
          translate([servo_shift, -pm_w/2, -5]){
            cube(size=[pm_wall, pm_wall, 0.1], center=true);
          }
        }

        // Servo side
        hull(){
          translate([0, pm_w/2, bm_h/2-pm_h+0.05]){
            cube(size=[pm_l, pm_wall, 0.1], center=true);
          }
          translate([pm_l/2-5, pm_w/2, 9]){
            rotate([90, 0, 0]){
              cylinder(d=10, h=pm_wall, center=true);
            }
          }
          translate([5-pm_l/2, pm_w/2, 9]){
            rotate([90, 0, 0]){
              cylinder(d=10, h=pm_wall, center=true);
            }
          }
        }
        //Inner enforcements
        translate([pm_l/4, 0, bm_h/2-pm_h+5]){
          cube(size=[pm_wall, pm_w, 10], center=true);
        }
        translate([-pm_l/4, 0, bm_h/2-pm_h+5]){
          cube(size=[pm_wall, pm_w, 10], center=true);
        }
        hull(){
          translate([pm_l/4, pm_w/4, bm_h/2-pm_h+0.05]){
            cube(size=[pm_wall, pm_w/2, 0.1], center=true);
          }
          translate([pm_l/4, pm_w/2, -7]){
            cube(size=[pm_wall, pm_wall, 0.1], center=true);
          }
        }
        hull(){
          translate([-pm_l/4, pm_w/2-5, bm_h/2-pm_h+0.05]){
            cube(size=[pm_wall, 10, 0.1], center=true);
          }
          translate([-pm_l/4, pm_w/2, -7]){
            cube(size=[pm_wall, pm_wall, 0.1], center=true);
          }
        }

        // Outer enforcements
        hull(){
          translate([-(pm_l-pm_wall)/2, pm_w/2+5, bm_h/2-pm_h+0.05]){
            cube(size=[pm_wall, 10, 0.1], center=true);
          }
          translate([-(pm_l-pm_wall)/2, pm_w/2+5, 0]){
            cube(size=[pm_wall, pm_wall, 0.1], center=true);
          }
          translate([-(pm_l-pm_wall)/2, pm_w/2, 10]){
            cube(size=[pm_wall, pm_wall, 0.1], center=true);
          }
        }

        hull(){
          translate([(pm_l-pm_wall)/2, pm_w/2+5, bm_h/2-pm_h+0.05]){
            cube(size=[pm_wall, 10, 0.1], center=true);
          }
          translate([(pm_l-pm_wall)/2, pm_w/2+5, 0]){
            cube(size=[pm_wall, pm_wall, 0.1], center=true);
          }
          translate([(pm_l-pm_wall)/2, pm_w/2, 10]){
            cube(size=[pm_wall, pm_wall, 0.1], center=true);
          }
        }
        
        // Base plate  
        translate([0, 5, bm_h/2-pm_h+pm_wall/2]){
          difference(){
            cube(size=[pm_l, pm_w+10, pm_wall], center=true);
            translate([mh_x, mh_y, 0]){
              cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
            }
            translate([-mh_x, mh_y, 0]){
              cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
            }
            translate([-mh_x, -mh_y, 0]){
              cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
            }
            translate([mh_x, -mh_y, 0]){
              cylinder(d=M3_hole, h=pm_wall*10.1, center=true);
            }
          }
        }
      }
      translate([servo_shift-10.4, 67.5, bm_h/2]){
        rotate([90, 0, 0]){
          servo(cable=false);
        }
      }
      // Cut pivot point
      translate([servo_shift, -pm_w/2, bm_h/2]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=pm_wall*1.1, center=true);
        }
      }
    }
    if(showServo==1){
      translate([servo_shift-10.4, 67.5, bm_h/2]){
        rotate([90, 0, 0]){
          servo(cable=false);
        }
      }
    }
  }    
  
  
}


module servo_horn(){
  horn_d = 41;
  horn_w1 = 12;
  horn_w2 = 6;
  horn_thickness = 3;
  horn_mount = 13.7;
  

  //cylinder($fn=tow, r=radius, h=wheel_w, center=true);
  x1=0;
  y1=horn_w1/2;
  x2=horn_d/2-horn_w2/2;
  y2=horn_w2/2;
  x3=horn_d/2-horn_w2/2;
  y3=-horn_w2/2;
  x4=0;
  y4=-horn_w1/2;
  
  for(i=[0:90:360]){
    rotate([0, 0, i]){
      translate([horn_mount, 0, -5]){
        cylinder(d=3, h=10.1, center=true);
      }
      translate([(horn_d-horn_w2)/2, 0, 0]){
        cylinder(d=horn_w2, h=horn_thickness, center=true);
      }
      translate([0, 0, -horn_thickness/2]){
        linear_extrude(height=horn_thickness){
          polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
        }
      }
    }
  }

}

module servo(tolerance=0, mount_holes=1, horn=true, cable=true){
  mh_dis1 = 49;
  mh_dis2 = 10;
  
  translate([0, 0, servo_h/2]){
    cube(size=[servo_l+tolerance, servo_w+tolerance, servo_h+tolerance], center=true);
      if(horn==true){
        translate([servo_l/2-servo_axis_offset, 0, 25]){
          rotate([0, 0, 90]){
            cylinder(d=30, h=2, center=true);
          }
        }
      }
  }
  translate([0, 0, servo_h1+1]){
    cube(size=[servo_lt, servo_w+tolerance, 3], center=true);
  }
  if(mount_holes == 1){
    if(cable==true){
      translate([-servo_l/2, 0, servo_h/2]){
        cylinder(d=7, h=servo_h, center=true);
      }
    }
    translate([mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([-mh_dis1/2, mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([-mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
    translate([mh_dis1/2, -mh_dis2/2, servo_h1+1]){
      cylinder(d=M3_hole, h=20, center=true);
    }
  }

  
}


module bar(length = 100, rot=[0, 0, 0], lab="1", edge = [0,0]){
  rotate(rot){
    if(edge[0] > 0 && edge[1] > 0){
      bar_edge(length, rot, lab, edge);
    }
    else{
      difference(){
        cube(size=[bar_e, bar_e, length], center=true);
        cube(size=[bar_e-2*bar_wall, bar_e-2*bar_wall, length+0.1], center=true);
      }
      rotate([180, 90, 0]){
        color( [1.0, 0.0, 0.0, 1.0] ) {
          translate([0, 0, bar_e/2+0.1]){
            linear_extrude(1, center = true) {
              text(lab, bar_e-1, halign = "center", valign = "center");
            }
          }
        }
      }
    } 
  }
}

module roundedRect(size, radius, edges=[1, 1, 1, 1]){
  x = size[0];
  y = size[1];
  z = size[2];

  linear_extrude(height=z){
    hull(){
        // place 4 circles in the corners, with the given radius
        if(edges[0]){
          translate([(-x/2)+(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
        if(edges[1]){
          translate([(x/2)-(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[2]){
          translate([(-x/2)+(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[3]){
          translate([(x/2)-(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
    }
  }
}
